0 value chp8-reg-i \ register I: address register (16-bit)
0 value chp8-reg \ registers 0 to F (8-bit)

0 value chp8-timestamp
fvariable chp8-delay-timer chp8-delay-timer 0e0 f! 
fvariable chp8-sound-timer chp8-sound-timer 0e0 f!

: chp8-get-reg { index -- }
  assert0( index -1 > )
  assert0( index 16 < )
  chp8-reg index + c@
;

: chp8-set-reg { index nvalue -- }
  assert0( index -1 > )
  assert0( index 16 < )
  nvalue chp8-reg index + c!
;

: print-regfile
  s" I: " type
  chp8-reg-i hex.
  s" delay: " type
  chp8-delay-timer f@ f.
  s" sound: " type
  chp8-sound-timer f@ f.
  s\" \n" type
  s" V0: " type
  chp8-reg 0 + c@ hex.
  s" V1: " type
  chp8-reg 1 + c@ hex.
  s" V2: " type
  chp8-reg 2 + c@ hex.
  s" V3: " type
  chp8-reg 3 + c@ hex.
  s" V4: " type
  chp8-reg 4 + c@ hex.
  s" V5: " type
  chp8-reg 5 + c@ hex.
  s" V6: " type
  chp8-reg 6 + c@ hex.
  s" V7: " type
  chp8-reg 7 + c@ hex.
  s" V8: " type
  chp8-reg 8 + c@ hex.
  s" V9: " type
  chp8-reg 9 + c@ hex.
  s" VA: " type
  chp8-reg 10 + c@ hex.
  s" VB: " type
  chp8-reg 11 + c@ hex.
  s" VC: " type
  chp8-reg 12 + c@ hex.
  s" VD: " type
  chp8-reg 13 + c@ hex.
  s" VE: " type
  chp8-reg 14 + c@ hex.
  s" VF: " type
  chp8-reg 15 + c@ hex.
  s\" \n" type
;

: push-return { addr -- }
  addr s>f
;

: pop-return { -- addr }
  assert0( fdepth 0 > )
  f>s
;
