#include <SDL2/SDL.h>

#define GENERATE(f, NAME) fprintf((f), "%lld constant %s\n", (long long) (NAME), #NAME)

int main() {
    FILE *f = fopen("sdl2constants.fs", "w");
   
    GENERATE(f, NULL); 
    GENERATE(f, SDL_INIT_VIDEO);
    GENERATE(f, SDL_KEYDOWN);
    GENERATE(f, SDL_QUIT);
    GENERATE(f, SDL_RENDERER_ACCELERATED);
    GENERATE(f, SDL_WINDOW_SHOWN);
    GENERATE(f, SDL_WINDOWPOS_UNDEFINED);

    GENERATE(f, SDL_SCANCODE_0);
    GENERATE(f, SDL_SCANCODE_1);
    GENERATE(f, SDL_SCANCODE_2);
    GENERATE(f, SDL_SCANCODE_3);
    GENERATE(f, SDL_SCANCODE_4);
    GENERATE(f, SDL_SCANCODE_5);
    GENERATE(f, SDL_SCANCODE_6);
    GENERATE(f, SDL_SCANCODE_7);
    GENERATE(f, SDL_SCANCODE_8);
    GENERATE(f, SDL_SCANCODE_9);
    GENERATE(f, SDL_SCANCODE_A);
    GENERATE(f, SDL_SCANCODE_B);
    GENERATE(f, SDL_SCANCODE_C);
    GENERATE(f, SDL_SCANCODE_D);
    GENERATE(f, SDL_SCANCODE_E);
    GENERATE(f, SDL_SCANCODE_F);
    GENERATE(f, SDL_SCANCODE_X);
    GENERATE(f, SDL_SCANCODE_Q);
    GENERATE(f, SDL_SCANCODE_W);
    GENERATE(f, SDL_SCANCODE_S);
    GENERATE(f, SDL_SCANCODE_Z);
    GENERATE(f, SDL_SCANCODE_R);
    GENERATE(f, SDL_SCANCODE_V);

    fclose(f);

    return 0;
}
